/*
 * CreatureCard.cs - A creature card
 *
 * Copyright (C) 2003  Peter Minten
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */ 

namespace DotGNU_TCG
{
	public class CreatureCard : Card
	{
		protected int attack, defense;
		protected byte ability; //A set using the old logic operators (||,&&)
		protected String onCreate; //When put on table
		protected String onAttack; //When attacking
		protected String onBlock; //When blocking
		protected String onDestroy; //When killed
		
		//Create a card
		public CreatureCard(ResourcePool requirements, int level, int cost, 
							Alignment alignment, String group, String picture, 
							String explanation, String quote, int attack, 
							int defense, byte ability, String onCreate, 
							String onAttack, String onBlock, String onDestroy) 
							:base(requirements, level, cost, alignment, group, 
								  picture, explanation, quote)
		{
			this.attack = attack;
			this.defense = defense;
			this.ability = ability;
			this.onCreate = onCreate;
			this.onAttack = onAttack;
			this.onBlock = onBlock;
			this.onDestroy = onDestroy;
		}
		
		//Block another creature card (do battle)
		public void Block(CreatureCard other)
		{
/*			//TODO: Special stuff like evaluating the Ruby strings
			
			//When a card is modified it's state changes
			
			//Simple battle, first check if opponent can be blocked
			if ((this.ability & other.ability) == other.ability)
			{
				//Blocking possible
				if (this.attack >= other.defense) 
					other.state = CardState.Destroyed;
				
				if (other.attack >= this.defense)
					this.state = CardState.Destroyed;
			}
			else
			{
				//Blocking not possible
			}*/
		}
	} //class CreatureCard
} //namespace DotGNU_TCG